<template>
  <div style="margin:3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :isValidate="true" :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"/>
      <el-row :gutter="20">
        <el-col :span="6" :offset="19">
           <el-button :disabled="Chapter.colorCap == 'text-green'" @click="reposition"  type="primary" v-if="!isContractsProvider">REVISAR REPOSICIÓN </el-button>
        </el-col>  
      </el-row>
    </header>

    <div class="flex justify-between" style="margin:3rem 6rem !important; color: white; background-color: #818181 !important; padding: 10px 30px" >
      <h3 class="bolt-light"> {{ material.originalTitle.toUpperCase() }}  - CAPÍTULO  {{Chapter.chapter}} </h3> 
      <span> REVISADO POR:   {{this.userLogin.toUpperCase()}} </span>
    </div>

    <!-- v-if="Chapter.colorCap == 'text-red'" --> 
 
        <el-row v-if="Chapter.observations[0].status !== '' && Chapter.observations[1].status !== '' && Chapter.observations[2].status !== '' " style="margin: 4rem 8rem" >
          <h3 class="text-red">OBSERVACIONES</h3>
        </el-row>
        <el-row v-if="Chapter.observations[0].status !== '' && Chapter.observations[1].status !== '' && Chapter.observations[2].status !== '' ">
          <el-col :span="21" :offset="3">
              <el-table style="width: 80%"
                :data="Chapter.observations"
                :header-cell-class-name="tableRowClassName"
                border>
                <el-table-column 
                  label="OBSERVACIONES" >
                  <template slot-scope="scope">
                    <div>{{ scope.row.observations }}</div>
                  </template>
                </el-table-column>
                <el-table-column 
                  label="DETALLE">
                  <template slot-scope="scope">
                    <div v-for="(item, index) in scope.row.detail" :key= "index">
                     <p> {{ item }} </p>
                    </div>
                  </template>
                </el-table-column>
                <el-table-column 
                label="ESTADO">
                <template slot-scope="scope">
                  <div v-if="scope.row.status !== 'CORREGIDO'" class="text-red">{{ scope.row.status }}</div>
                  <div v-else>
                    <el-button type="primary" plain size="small" @click="dialogVisible = true">CORREGIDO </el-button>
                  </div>              
                </template>
              </el-table-column>                                   
            </el-table>
          </el-col>
        </el-row>


        <!-- MODAL DE REPOSICION DE LOS CAPITULOS -->
        <el-dialog
          :visible.sync="dialogVisible"
          width="60%" >
          <div  style="margin:2rem; color: white; background-color: #818181 !important; padding: 10px 30px" >
            <h3 class="bolt-light"> {{ material.originalTitle.toUpperCase() }}  - CAPÍTULO  {{Chapter.chapter}} </h3> 
          </div>
          <h3 class="text-orange" style="margin:3rem 2rem"> REPOSICIONES DEL CAPÍTULO </h3>
             <el-table style="width: 90%; margin:3rem 2rem"
                :data="Chapter.correctionObservations"
                :header-cell-class-name="tableRowClassName"
                border>
                <el-table-column 
                  label="OBSERVACIONES" width="190%">
                  <template slot-scope="scope">
                    <div>{{ scope.row.observations }}</div>
                  </template>
                </el-table-column>
                <el-table-column 
                  label="Fecha de Llegada" prop="arrivalDate" width="190%">          
                </el-table-column>
                 <el-table-column 
                  label="Obs. Corregida">
                  <template slot-scope="scope">
                    <div v-for="(item, index) in scope.row.detail" :key= "index">
                     <p> {{ item }} </p>
                    </div>
                  </template>
                </el-table-column>                                      
            </el-table>
            
        </el-dialog>

       <section style="margin:6rem 6rem 3rem">
          <div style="margin:2rem 3rem">
            <h3 class="text-orange" style="margin-bottom:1.5rem">  DATOS DEL CAPÍTULO </h3>
            <div style="margin:3rem 1rem">
            <!-- SECCION TEMPORADAS DEL MATERIAL -->
            <el-row>
              <el-col :span="0.10" style="padding-right:10px">
                <i class="icon-edit" style="color: #BDBDBD"></i>
              </el-col>
              <el-col :span="10">
                <h4 class="text-dark" style="margin-bottom:1.5rem"> TÍTULO DEL CAPÍTULO </h4>
                <p>   {{ Chapter.titleChapter }} </p>
              </el-col>
            </el-row>

            <el-row>
                <el-col :span="12">               
                  <el-row style="margin-top: 4rem">
                      <el-col :span="0.10" style="padding-right:10px">
                        <i class="icon-clock" style="color: #BDBDBD"></i>
                      </el-col>
                      <el-col :span="22" style="border-right: 1px solid var(--color-grey-darken-2);">
                        <h4 class="text-dark" style="margin-bottom:1.5rem"> DURACIÓN </h4>
                        <p>
                          <span v-if="Chapter.hourChapter"> {{ Chapter.hourChapter }}  h </span>
                          <span v-else> 0h</span>

                          <span v-if="Chapter.minChapter"> {{ Chapter.minChapter}} min  </span>
                          <span v-else> 0min</span>

                          <span v-if="Chapter.secChapter">  {{ Chapter.secChapter }} s </span>
                          <span v-else> 0s</span>

                           </p>
                      </el-col>
                  </el-row>                
                </el-col>
                <el-col :span="11" style="margin-left:20px">
                    <el-row style="margin-top: 4rem">
                        <el-col :span="0.10" style="padding-right:10px">
                          <i class="el-icon-star-off" style="color: #BDBDBD"></i>
                          <!-- <i class="icon-artist"></i> -->
                        </el-col>
                        <el-col :span="20">
                            <h4 class="text-dark" style="margin-bottom:1.5rem"> ARTISTAS INVITADOS: </h4>
                            <span v-for="(item, index) in Chapter.guestArtis" :key="index">
                              <p>{{item.artist }}</p>
                            </span>
                        </el-col>
                    </el-row>
                </el-col>
            </el-row> 
          
            <el-row>
                <el-col :span="12">               
                  <el-row style="margin-top: 4rem">
                      <el-col :span="0.10" style="padding-right:10px">
                        <i class="icon-edit" style="color: #BDBDBD"></i>
                        <!-- <i class="el-icon-edit"></i> -->
                      </el-col>
                      <el-col :span="22" style="border-right: 1px solid var(--color-grey-darken-2);">
                        <h4 class="text-dark" style="margin-bottom:1.5rem"> SIPNOSIS: </h4>
                        <p style="padding-right:30px"> {{ Chapter.synopsisChapter }} </p>
                      </el-col>
                  </el-row>                
                </el-col>
                <el-col :span="11" style="margin-left:20px">
                  <el-row style="margin-top: 4rem">
                    <el-col :span="0.10" style="padding-right:10px">
                      <i class="icon-edit" style="color: #BDBDBD"></i>
                    </el-col>
                    <el-col :span="20" >
                      <h4 class="text-dark" style="margin-bottom:1.5rem"> TEMA DEL CAPÍTULO: </h4>
                        <p>{{ Chapter.themeChapter }}</p>
                    </el-col>
                  </el-row>
                </el-col>
            </el-row> 

            <el-row>
              <el-col :span="12">
                <el-row style="margin-top: 4rem">
                  <el-col :span="0.10" style="padding-right:10px">
                    <i class="icon-ticket" style="color: #BDBDBD"></i>
                  </el-col>
                  <el-col :span="22" style="border-right: 1px solid var(--color-grey-darken-2);">
                    <h4 class="text-dark" style="margin-bottom:1.5rem"> ETIQUETAS: </h4>
                      <el-tag v-for="(item, index) in Chapter.tags"
                        :key="index" type="info">
                        {{item}}
                    </el-tag>
                  </el-col>
                </el-row>
              </el-col>
              <el-col :span="11" style="margin-left:20px">
                <el-row style="margin-top: 4rem">
                  <el-col :span="0.10" style="padding-right:10px">
                    <i class="el-icon-star-off" style="color: #BDBDBD"></i>
                  </el-col>
                  <el-col :span="20" >
                    <h4 class="text-dark" style="margin-bottom:1.5rem"> CALIFICACIÓN </h4>
                    <el-rate v-model="Chapter.scoreStartCap" disabled ></el-rate>
                  </el-col>
                  <!--Se puede agregar observaciones si el usuario lo necesita, pero se le agregaria una condicional para que se vean las condiciones si es que hay-->
                  <!-- <p>{{Chapter.additionalRemarksChapter}}</p> -->
                </el-row>
              </el-col>
              <el-col :span="11" v-if="Chapter.additionalRemarksChapter && Chapter.additionalRemarksChapter !== ''">
                <el-row style="margin-top: 4rem">
                  <el-col :span="0.10">
                    <i class="icon-edit" style="color: #BDBDBD"></i>
                  </el-col>
                  <el-col :span="11" style="margin-left:10px">
                    <h4 class="text-dark" style="margin-bottom:1.5rem"> OBSERVACIONES DEL CAPÍTULO: </h4>
                    <p v-html="addBreakLines(Chapter.additionalRemarksChapter)"></p>
                  </el-col>
                </el-row>
              </el-col>
              
            </el-row>

            </div>
     

          </div>
        </section>
        <!-- </div> 
      </div> -->
      <!-- 
      <div>
        <div class="form-caps" style="margin: 0 10rem"> -->

      <section style="margin:3rem 6rem">
        <hr class= "line-card-gray">
        <el-row style="margin: 4rem 2rem 2rem">
          <h3 class="text-orange" style="margin: 1rem 0">FICHA TÉCNICA</h3>
        </el-row>

        <el-row  style="margin: 1rem 3rem">
          <el-row type="flex" justify="start" style="align-items: center;">
              <i class="icon-tv pr-5 font-size-25" style="color: #BDBDBD"></i>
              <p class="fonts-bold-general" style="margin: 1rem 0">  <strong>RESOLUCIÓN DE MATERIAL:</strong></p>
          </el-row>
          <el-col :span="20">

            <el-row style="margin-bottom:0.5rem" class="ml-30">
              <el-col :span="4">
                 <p><strong>Pantalla:</strong></p>
              </el-col>
              <el-col :span="6">
                <p>{{ Chapter.screenChapter }}</p>
              </el-col>
            </el-row>
            <el-row class="ml-30">
              <el-col :span="4">
                 <p><strong>Resolución:</strong></p>
              </el-col>
              <el-col :span="6">
                <p>{{ Chapter.screenResolutionChapter }}</p>
              </el-col>
            </el-row>
           
          </el-col>
        </el-row>

        <hr class= "line-card-gray">
        <el-row style="margin: 3rem 2rem">
          <h3 class="text-orange" style="margin: 1rem 0">INGRESO DEL MATERIAL</h3>
        </el-row> 
        <el-table style="width: 100%; margin: 1rem 3rem 6rem" 
          :data="(afiliado == 'true')?[Chapter]:infoByCap"
          :header-cell-class-name="tableRowClassName"
          border>
          <el-table-column 
          label="FECHA DE LLEGADA">
            <template slot-scope="scope">
              <div>{{(scope.row.arrivalDate)? new Date(scope.row.arrivalDate).toLocaleDateString('en-GB') :'No Ingresado'}}</div>
            </template>
          </el-table-column>
          <el-table-column 
          label="FECHA DE COPIADO">
            <template slot-scope="scope">
              <div>{{dateOfCopy(scope.row)}}</div>
            </template>
          </el-table-column>
          <el-table-column 
          label="MODO DE ENVÍO">
            <template slot-scope="scope">
              <div>{{ (scope.row.shippingMode)?scope.row.shippingMode:'No Ingresado' }}</div>
            </template>
          </el-table-column>
          <el-table-column 
          label="ALMACENAMIENTO">
            <template slot-scope="scope">
              <div>{{storages(scope.row)}}</div>
            </template>
          </el-table-column>
          <el-table-column 
          label="CÓDIGO DE DISCO" >
            <template slot-scope="scope">
              <div>{{supportMaterial(scope.row)}}</div>
            </template>
          </el-table-column>                                    
        </el-table>
      </section>       
                      
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import { HTTP } from '@/main.js'

export default {
  components: {
    ReturnButton,
  },
  data() {
    return {
      material: JSON.parse(this.$localStorage.get("selectedMaterial")),
      userLogin: localStorage.getItem('userName'),
      Chapter: {},
      storageSupport:[],
      temporada: 0,
      capitulo: 0,
      infoByCap: [],
      arrayChapter: [],
      dialogVisible: false,
      afiliado: localStorage.getItem('afiliado'),
      admittedMaterialsStorage: [],
      isContractsProvider: false,
      textNotInsert: 'No ingresado'
    }
  },
  created() {
    console.log(this.$route.params)
    // console.log(this.material, 'material___')
    this.Chapter = this.$route.params.chapter
    this.arrayChapter = []
    this.arrayChapter.push(this.$route.params.chapter)
    this.temporada = (this.$route.params.temporada - 1)
    this.capitulo = (this.$route.params.capitulo - 1)
    if(this.afiliado == 'false'){
      this.getStorageSupport(this.material.contractCode, this.material.__id)
    }
    this.isContractsProvider = this.$route.params.isContractsProvider
    console.log(this.isContractsProvider,'isContractsProvider')
    // console.log(this.material, 'material')
  },
  methods: {
    dateOfCopy(value){
      const {dateOfCopy, dateCopy} = value
      let element = dateOfCopy ? dateOfCopy : dateCopy ? dateCopy :  this.textNotInsert
      let result = element && element !== this.textNotInsert ? new Date(element).toLocaleDateString('en-GB') :  this.textNotInsert
      return result
    },
    storages(value){
      const {storages, storage} = value
      let element = storages ? storages : storage ? storage : this.textNotInsert
      let result = element && element !==  this.textNotInsert ? element : this.textNotInsert
      return result
    },
    supportMaterial(value){
      const {supportMaterial, typeStorage} = value
      let result = "" 
      if(supportMaterial && supportMaterial.length > 0 && supportMaterial[0].codeDisk !== '') {
        result = supportMaterial[0].codeDisk
      } else if(typeStorage && typeStorage.length > 0 && typeStorage[0].codeDisk !== '') {
        result = typeStorage[0].codeDisk
      } else {
        result = this.textNotInsert
      }
      return result
    },
    addBreakLines(text) {
      if(text) {
        let value = text.split('\n')
        let unionValue = value.join('</br>')
        return unionValue
      } else {
        return ''
      }
    },
    reposition() {
      this.$router.push({name: 'repositionMaterialsWithCap', params: { chapter: this.Chapter, temporada: this.temporada, capitulo: this.capitulo } })
    },
    getStorageSupport(idContract, idMaterial) {
      HTTP.get(`contracts/contractCode/${idContract}`)
        .then(res => {
          this.infoByCap = []
          this.admittedMaterialsStorage = res.data.contract[0].admittedMaterials
           this.admittedMaterialsStorage.map((el, i, arr) => {
            if(el._id  === idMaterial ) {
              this.infoByCap.push(el.numChapters[this.temporada].infoByChapter[this.capitulo])
            }
          })
          console.log(this.infoByCap, 'infoByCap-----')
        })
       .catch(err => console.log(err));
      },
      tableRowClassName({
         row, rowIndex
      }) {
        if (rowIndex === 0) {
            return 'bg-light-red';
        }
      },
    returnPage() {
      if ( this.isContractsProvider === true ){
        this.$router.push({name: 'reportCap', params: { isContractsProvider: true }}) 
      }
      else {
        this.$router.push({name: 'reportCap'}) 
      }
       
    }
  },
  mounted() {
    let a = JSON.parse(this.$localStorage.get("selectedMaterial"))
    console.log({a})
  }
}
</script>

